// box.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "sampling.h"
#include "paramset.h"
// Box Filter Declarations
class BoxFilter : public Filter {
public:
	BoxFilter(Float xw, Float yw) : Filter(xw, yw) { }
	Float Evaluate(Float x, Float y) const;
};
// Box Filter Definitions
Float BoxFilter::Evaluate(Float x, Float y) const {
	return 1.;
}
extern "C" Filter *CreateFilter(const ParamSet &ps, Float xw, Float yw) {
	return new BoxFilter(xw, yw);
}
