// windy.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "lrt.h"
#include "materials.h"
// Windy Creation Function
extern "C" Texture<Float> *CreateBump(const Transform &shader2world,
		const ParamSet &geomParams,
		const ParamSet &displaceParams) {
	Float stretch = DISP_FLOAT_PARAM("stretch", 1.);
	stretch=0.01;
	Transform sc = Scale(stretch, stretch, stretch);
	Transform rot = RotateY(32.0f);
	Transform rot2 = RotateZ(16.1f);
	Transform tr = Translate(Vector(333,444,555));

	Texture<Float> *d = new Windy(new IdentityMapping3D(sc*rot*rot2*tr));
	DISP_TEX_F(scale, 10);
	return new ScaleTexture<Float, Float>(scale, d);
}
