/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     ID = 259,
     NUM = 260,
     LBRACK = 261,
     RBRACK = 262,
     DASH = 263,
     ACCELERATOR = 264,
     AREALIGHTSOURCE = 265,
     ATMOSPHERE = 266,
     ATTRIBUTE = 267,
     ATTRIBUTEBEGIN = 268,
     ATTRIBUTEEND = 269,
     BASIS = 270,
     BOUND = 271,
     CLIPPING = 272,
     COLOR = 273,
     COLORSAMPLES = 274,
     CONCATTRANSFORM = 275,
     CONE = 276,
     COORDINATESYSTEM = 277,
     CROPWINDOW = 278,
     CYLINDER = 279,
     DECLARE = 280,
     DEFORMATION = 281,
     DEPTHOFFIELD = 282,
     DETAIL = 283,
     DETAILRANGE = 284,
     DISK = 285,
     DISPLACEMENT = 286,
     DISPLAY = 287,
     EXPOSURE = 288,
     EXTERIOR = 289,
     FORMAT = 290,
     FRAMEASPECTRATIO = 291,
     FRAMEBEGIN = 292,
     FRAMEEND = 293,
     GENERALPOLYGON = 294,
     GEOMETRICAPPROXIMATION = 295,
     GEOMETRY = 296,
     HIDER = 297,
     HYPERBOLOID = 298,
     IDENTITY = 299,
     ILLUMINATE = 300,
     IMAGER = 301,
     INTERIOR = 302,
     LIGHTSOURCE = 303,
     LOOKAT = 304,
     MAKEBUMP = 305,
     MAKECUBEFACEENVIRONMENT = 306,
     MAKELATLONGENVIRONMENT = 307,
     MAKESHADOW = 308,
     MAKETEXTURE = 309,
     MATTE = 310,
     MOTIONBEGIN = 311,
     MOTIONEND = 312,
     NUPATCH = 313,
     OBJECTBEGIN = 314,
     OBJECTEND = 315,
     OBJECTINSTANCE = 316,
     OPACITY = 317,
     OPTION = 318,
     ORIENTATION = 319,
     PARABOLOID = 320,
     PATCH = 321,
     PATCHMESH = 322,
     PERSPECTIVE = 323,
     PIXELFILTER = 324,
     PIXELSAMPLES = 325,
     PIXELVARIANCE = 326,
     POINTSGENERALPOLYGONS = 327,
     POINTSPOLYGONS = 328,
     POLYGON = 329,
     PROJECTION = 330,
     QUANTIZE = 331,
     RELATIVEDETAIL = 332,
     REVERSEORIENTATION = 333,
     ROTATE = 334,
     SAMPLER = 335,
     SCALE = 336,
     SCREENWINDOW = 337,
     SEARCHPATH = 338,
     SHADINGINTERPOLATION = 339,
     SHADINGRATE = 340,
     SHUTTER = 341,
     SIDES = 342,
     SKEW = 343,
     SOLIDBEGIN = 344,
     SOLIDEND = 345,
     SPHERE = 346,
     SUBDIVISIONMESH = 347,
     SURFACE = 348,
     SURFACEINTEGRATOR = 349,
     TEXTURECOORDINATES = 350,
     TONEMAP = 351,
     TORUS = 352,
     TRANSFORM = 353,
     TRANSFORMBEGIN = 354,
     TRANSFORMEND = 355,
     TRANSLATE = 356,
     TRIMCURVE = 357,
     VERSION = 358,
     VOLUME = 359,
     VOLUMEINTEGRATOR = 360,
     WORLDBEGIN = 361,
     WORLDEND = 362,
     HIGH_PRECEDENCE = 363
   };
#endif
#define STRING 258
#define ID 259
#define NUM 260
#define LBRACK 261
#define RBRACK 262
#define DASH 263
#define ACCELERATOR 264
#define AREALIGHTSOURCE 265
#define ATMOSPHERE 266
#define ATTRIBUTE 267
#define ATTRIBUTEBEGIN 268
#define ATTRIBUTEEND 269
#define BASIS 270
#define BOUND 271
#define CLIPPING 272
#define COLOR 273
#define COLORSAMPLES 274
#define CONCATTRANSFORM 275
#define CONE 276
#define COORDINATESYSTEM 277
#define CROPWINDOW 278
#define CYLINDER 279
#define DECLARE 280
#define DEFORMATION 281
#define DEPTHOFFIELD 282
#define DETAIL 283
#define DETAILRANGE 284
#define DISK 285
#define DISPLACEMENT 286
#define DISPLAY 287
#define EXPOSURE 288
#define EXTERIOR 289
#define FORMAT 290
#define FRAMEASPECTRATIO 291
#define FRAMEBEGIN 292
#define FRAMEEND 293
#define GENERALPOLYGON 294
#define GEOMETRICAPPROXIMATION 295
#define GEOMETRY 296
#define HIDER 297
#define HYPERBOLOID 298
#define IDENTITY 299
#define ILLUMINATE 300
#define IMAGER 301
#define INTERIOR 302
#define LIGHTSOURCE 303
#define LOOKAT 304
#define MAKEBUMP 305
#define MAKECUBEFACEENVIRONMENT 306
#define MAKELATLONGENVIRONMENT 307
#define MAKESHADOW 308
#define MAKETEXTURE 309
#define MATTE 310
#define MOTIONBEGIN 311
#define MOTIONEND 312
#define NUPATCH 313
#define OBJECTBEGIN 314
#define OBJECTEND 315
#define OBJECTINSTANCE 316
#define OPACITY 317
#define OPTION 318
#define ORIENTATION 319
#define PARABOLOID 320
#define PATCH 321
#define PATCHMESH 322
#define PERSPECTIVE 323
#define PIXELFILTER 324
#define PIXELSAMPLES 325
#define PIXELVARIANCE 326
#define POINTSGENERALPOLYGONS 327
#define POINTSPOLYGONS 328
#define POLYGON 329
#define PROJECTION 330
#define QUANTIZE 331
#define RELATIVEDETAIL 332
#define REVERSEORIENTATION 333
#define ROTATE 334
#define SAMPLER 335
#define SCALE 336
#define SCREENWINDOW 337
#define SEARCHPATH 338
#define SHADINGINTERPOLATION 339
#define SHADINGRATE 340
#define SHUTTER 341
#define SIDES 342
#define SKEW 343
#define SOLIDBEGIN 344
#define SOLIDEND 345
#define SPHERE 346
#define SUBDIVISIONMESH 347
#define SURFACE 348
#define SURFACEINTEGRATOR 349
#define TEXTURECOORDINATES 350
#define TONEMAP 351
#define TORUS 352
#define TRANSFORM 353
#define TRANSFORMBEGIN 354
#define TRANSFORMEND 355
#define TRANSLATE 356
#define TRIMCURVE 357
#define VERSION 358
#define VOLUME 359
#define VOLUMEINTEGRATOR 360
#define WORLDBEGIN 361
#define WORLDEND 362
#define HIGH_PRECEDENCE 363




/* Copy the first part of user declarations.  */
#line 8 "ri/ribparse.y"

#include "ri.h"
#include "lrt.h"

#include <stdarg.h>

extern int yylex( void );
int line_num = 0;
string current_file;

#define YYMAXDEPTH 100000000

void yyerror( char *str ) {
	Error( "RIB parsing error: %s", str);
}

void ParseError( const char *format, ... ) PRINTF_FORMAT;

void ParseError( const char *format, ... ) {
	char error[4096];
	va_list args;
	va_start( args, format );
	vsprintf( error, format, args );
	yyerror(error);
	va_end( args );
}

#define MAX_LIGHT_HANDLE 65536
static void *lights[MAX_LIGHT_HANDLE];

int cur_paramlist_allocated = 0;
int cur_paramlist_size = 0;
const char **cur_paramlist_tokens = NULL;
void **cur_paramlist_args = NULL;
int *cur_paramlist_sizes = NULL;

#define CPS cur_paramlist_size
#define CPT cur_paramlist_tokens
#define CPA cur_paramlist_args
#define CPSZ cur_paramlist_sizes

typedef struct RIB_array {
	int element_size;
	int allocated;
	int nelems;
	void *array;
} RIB_array;

RIB_array *cur_array = NULL;

#define NA(r) ((Float *) r->array)
#define SA(r) ((const char **) r->array)

void AddArrayElement( void *elem ) {
	if (cur_array->nelems >= cur_array->allocated) {
		cur_array->allocated = 2*cur_array->allocated + 1;
		cur_array->array = realloc( cur_array->array,
			cur_array->allocated*cur_array->element_size );
	}
	char *next = ((char *)cur_array->array) + cur_array->nelems *
		cur_array->element_size;
	memcpy( next, elem, cur_array->element_size );
	cur_array->nelems++;
}

RIB_array *ArrayDup( RIB_array *ra )
{
	RIB_array *ret = new RIB_array;
	ret->element_size = ra->element_size;
	ret->allocated = ra->allocated;
	ret->nelems = ra->nelems;
	ret->array = malloc(ra->nelems * ra->element_size);
	memcpy( ret->array, ra->array, ra->nelems * ra->element_size );
	return ret;
}

void ArrayFree( RIB_array *ra )
{
	free(ra->array);
	delete ra;
}

void FreeArgs()
{
	for (int i = 0; i < cur_paramlist_size; ++i)
		delete[] ((char *)cur_paramlist_args[i]);
}

static Float * FindBasis( const char *str )
{
	/*
	if (!strcmp( str, "bezier" )) return (Float *) RiBezierBasis;
	else if (!strcmp( str, "b-spline" )) return (Float *) RiBSplineBasis;
	else if (!strcmp( str, "catmull-rom" )) return (Float *) RiCatmullRomBasis;
	else if (!strcmp( str, "hermite" )) return (Float *) RiHermiteBasis;
	else if (!strcmp( str, "power" )) return (Float *) RiPowerBasis;
	else ParseError( "Unknown basis: %s", str );
	*/

	Warning("Named bases aren't supported yet...");

	return NULL;
}
static bool VerifyArrayLength( RIB_array *arr, int required,
	const char *command ) {
	if (arr->nelems != required) {
		ParseError( "%s requires a(n) %d element array!", command, required);
		return false;
	}
	return true;
}

static int *MakeIntArray( RIB_array *arr )
{
	int *ret = new int[arr->nelems];
	for (int i = 0 ; i < arr->nelems ; i++)
		ret[i] = int(NA(arr)[i]);
	return ret;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 130 "ri/ribparse.y"
typedef union YYSTYPE {
char string[1024];
Float num;
RIB_array *ribarray;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 419 "ri/ribparse.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 431 "ri/ribparse.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  212
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   660

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  109
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  22
/* YYNRULES -- Number of rules. */
#define YYNRULES  146
/* YYNRULES -- Number of states. */
#define YYNSTATES  447

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   363

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     6,     7,     8,    10,    12,    14,
      16,    21,    24,    27,    29,    32,    34,    36,    41,    44,
      47,    49,    52,    55,    56,    59,    60,    63,    66,    68,
      71,    75,    80,    84,    88,    90,    92,    98,   104,   110,
     116,   124,   127,   131,   136,   139,   143,   149,   153,   156,
     159,   165,   168,   175,   179,   183,   187,   192,   200,   203,
     209,   212,   218,   222,   226,   232,   236,   240,   245,   248,
     251,   253,   257,   261,   265,   269,   279,   283,   285,   289,
     293,   297,   302,   313,   323,   337,   345,   350,   360,   363,
     366,   368,   381,   384,   386,   389,   394,   397,   401,   404,
     411,   415,   419,   427,   430,   436,   440,   443,   449,   454,
     457,   461,   468,   471,   473,   479,   483,   488,   494,   497,
     500,   503,   506,   510,   513,   522,   525,   528,   530,   537,
     541,   547,   551,   555,   565,   568,   572,   580,   584,   587,
     589,   591,   596,   607,   611,   615,   617
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
     110,     0,    -1,   129,    -1,    -1,    -1,    -1,   115,    -1,
     120,    -1,   116,    -1,   117,    -1,   111,     6,   118,     7,
      -1,   111,   119,    -1,   118,   119,    -1,   119,    -1,   112,
       3,    -1,   121,    -1,   122,    -1,   111,     6,   123,     7,
      -1,   111,   124,    -1,   123,   124,    -1,   124,    -1,   113,
       5,    -1,   126,   127,    -1,    -1,   128,   127,    -1,    -1,
       3,   114,    -1,   129,   130,    -1,   130,    -1,   103,     5,
      -1,     9,     3,   125,    -1,    10,     3,     5,   125,    -1,
      11,     3,   125,    -1,    12,     3,   125,    -1,    13,    -1,
      14,    -1,    15,     3,     5,     3,     5,    -1,    15,     3,
       5,   121,     5,    -1,    15,   121,     5,     3,     5,    -1,
      15,   121,     5,   121,     5,    -1,    16,     5,     5,     5,
       5,     5,     5,    -1,    16,   121,    -1,    17,     5,     5,
      -1,    18,     5,     5,     5,    -1,    18,   121,    -1,    19,
     121,   121,    -1,    21,     5,     5,     5,   125,    -1,    21,
     121,   125,    -1,    20,   120,    -1,    22,     3,    -1,    23,
       5,     5,     5,     5,    -1,    23,   121,    -1,    24,     5,
       5,     5,     5,   125,    -1,    24,   121,   125,    -1,    25,
       3,     3,    -1,    26,     3,   125,    -1,    27,     5,     5,
       5,    -1,    28,     5,     5,     5,     5,     5,     5,    -1,
      28,   121,    -1,    29,     5,     5,     5,     5,    -1,    29,
     121,    -1,    30,     5,     5,     5,   125,    -1,    30,   121,
     125,    -1,    31,     3,   125,    -1,    32,     3,     3,     3,
     125,    -1,    33,     5,     5,    -1,    34,     3,   125,    -1,
      35,     5,     5,     5,    -1,    36,     5,    -1,    37,     5,
      -1,    38,    -1,    39,   120,   125,    -1,    40,     3,     5,
      -1,    41,     3,   125,    -1,    42,     3,   125,    -1,    43,
       5,     5,     5,     5,     5,     5,     5,   125,    -1,    43,
     121,   125,    -1,    44,    -1,    45,     5,     5,    -1,    46,
       3,   125,    -1,    47,     3,   125,    -1,    48,     3,     5,
     125,    -1,    49,     5,     5,     5,     5,     5,     5,     5,
       5,     5,    -1,    50,     3,     3,     3,     3,     3,     5,
       5,   125,    -1,    51,     3,     3,     3,     3,     3,     3,
       3,     5,     3,     5,     5,   125,    -1,    52,     3,     3,
       3,     5,     5,   125,    -1,    53,     3,     3,   125,    -1,
      54,     3,     3,     3,     3,     3,     5,     5,   125,    -1,
      55,     5,    -1,    56,   120,    -1,    57,    -1,    58,     5,
       5,   121,     5,     5,     5,     5,   121,     5,     5,   125,
      -1,    59,     5,    -1,    60,    -1,    61,     5,    -1,    62,
       5,     5,     5,    -1,    62,   121,    -1,    63,     3,   125,
      -1,    64,     3,    -1,    65,     5,     5,     5,     5,   125,
      -1,    65,   121,   125,    -1,    66,     3,   125,    -1,    67,
       3,     5,     3,     5,     3,   125,    -1,    68,     5,    -1,
      69,     3,     5,     5,   125,    -1,    70,     5,     5,    -1,
      71,     5,    -1,    72,   120,   120,   120,   125,    -1,    73,
     120,   120,   125,    -1,    74,   125,    -1,    75,     3,   125,
      -1,    76,     3,     5,     5,     5,     5,    -1,    77,     5,
      -1,    78,    -1,    79,     5,     5,     5,     5,    -1,    80,
       3,   125,    -1,    81,     5,     5,     5,    -1,    82,     5,
       5,     5,     5,    -1,    82,   121,    -1,    83,     3,    -1,
      84,     3,    -1,    85,     5,    -1,    86,     5,     5,    -1,
      87,     5,    -1,    88,     5,     5,     5,     5,     5,     5,
       5,    -1,    88,   121,    -1,    89,     3,    -1,    90,    -1,
      91,     5,     5,     5,     5,   125,    -1,    91,   121,   125,
      -1,    92,     3,   120,   120,   125,    -1,    93,     3,   125,
      -1,    94,     3,   125,    -1,    95,     5,     5,     5,     5,
       5,     5,     5,     5,    -1,    95,   121,    -1,    96,     3,
     125,    -1,    97,     5,     5,     5,     5,     5,   125,    -1,
      97,   121,   125,    -1,    98,   121,    -1,    99,    -1,   100,
      -1,   101,     5,     5,     5,    -1,   102,   120,   120,   120,
     120,   120,   120,   120,   120,   120,    -1,   105,     3,   125,
      -1,   104,     3,   125,    -1,   106,    -1,   107,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   168,   168,   170,   179,   184,   189,   193,   198,   202,
     207,   211,   213,   214,   216,   222,   226,   231,   235,   237,
     238,   240,   246,   248,   253,   254,   256,   272,   273,   275,
     276,   281,   290,   295,   300,   304,   308,   314,   322,   330,
     337,   344,   350,   354,   361,   367,   382,   387,   393,   399,
     403,   407,   413,   418,   425,   429,   434,   438,   445,   451,
     455,   461,   466,   473,   478,   483,   487,   492,   496,   500,
     504,   508,   516,   520,   525,   530,   538,   549,   553,   567,
     572,   577,   586,   590,   595,   601,   606,   611,   616,   620,
     625,   629,   637,   641,   645,   649,   655,   661,   666,   670,
     675,   682,   687,   692,   696,   701,   705,   709,   727,   748,
     770,   775,   779,   783,   787,   791,   796,   800,   804,   810,
     814,   818,   822,   826,   830,   834,   841,   845,   849,   854,
     861,   886,   891,   896,   900,   907,   912,   917,   925,   931,
     935,   939,   943,   966,   971,   976,   980
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "ID", "NUM", "LBRACK", "RBRACK", 
  "DASH", "ACCELERATOR", "AREALIGHTSOURCE", "ATMOSPHERE", "ATTRIBUTE", 
  "ATTRIBUTEBEGIN", "ATTRIBUTEEND", "BASIS", "BOUND", "CLIPPING", "COLOR", 
  "COLORSAMPLES", "CONCATTRANSFORM", "CONE", "COORDINATESYSTEM", 
  "CROPWINDOW", "CYLINDER", "DECLARE", "DEFORMATION", "DEPTHOFFIELD", 
  "DETAIL", "DETAILRANGE", "DISK", "DISPLACEMENT", "DISPLAY", "EXPOSURE", 
  "EXTERIOR", "FORMAT", "FRAMEASPECTRATIO", "FRAMEBEGIN", "FRAMEEND", 
  "GENERALPOLYGON", "GEOMETRICAPPROXIMATION", "GEOMETRY", "HIDER", 
  "HYPERBOLOID", "IDENTITY", "ILLUMINATE", "IMAGER", "INTERIOR", 
  "LIGHTSOURCE", "LOOKAT", "MAKEBUMP", "MAKECUBEFACEENVIRONMENT", 
  "MAKELATLONGENVIRONMENT", "MAKESHADOW", "MAKETEXTURE", "MATTE", 
  "MOTIONBEGIN", "MOTIONEND", "NUPATCH", "OBJECTBEGIN", "OBJECTEND", 
  "OBJECTINSTANCE", "OPACITY", "OPTION", "ORIENTATION", "PARABOLOID", 
  "PATCH", "PATCHMESH", "PERSPECTIVE", "PIXELFILTER", "PIXELSAMPLES", 
  "PIXELVARIANCE", "POINTSGENERALPOLYGONS", "POINTSPOLYGONS", "POLYGON", 
  "PROJECTION", "QUANTIZE", "RELATIVEDETAIL", "REVERSEORIENTATION", 
  "ROTATE", "SAMPLER", "SCALE", "SCREENWINDOW", "SEARCHPATH", 
  "SHADINGINTERPOLATION", "SHADINGRATE", "SHUTTER", "SIDES", "SKEW", 
  "SOLIDBEGIN", "SOLIDEND", "SPHERE", "SUBDIVISIONMESH", "SURFACE", 
  "SURFACEINTEGRATOR", "TEXTURECOORDINATES", "TONEMAP", "TORUS", 
  "TRANSFORM", "TRANSFORMBEGIN", "TRANSFORMEND", "TRANSLATE", "TRIMCURVE", 
  "VERSION", "VOLUME", "VOLUMEINTEGRATOR", "WORLDBEGIN", "WORLDEND", 
  "HIGH_PRECEDENCE", "$accept", "start", "array_init", 
  "string_array_init", "num_array_init", "array", "string_array", 
  "real_string_array", "single_element_string_array", "string_list", 
  "string_list_entry", "num_array", "real_num_array", 
  "single_element_num_array", "num_list", "num_list_entry", "paramlist", 
  "paramlist_init", "paramlist_contents", "paramlist_entry", 
  "ri_stmt_list", "ri_stmt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,   109,   110,   111,   112,   113,   114,   114,   115,   115,
     116,   117,   118,   118,   119,   120,   120,   121,   122,   123,
     123,   124,   125,   126,   127,   127,   128,   129,   129,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     0,     0,     1,     1,     1,     1,
       4,     2,     2,     1,     2,     1,     1,     4,     2,     2,
       1,     2,     2,     0,     2,     0,     2,     2,     1,     2,
       3,     4,     3,     3,     1,     1,     5,     5,     5,     5,
       7,     2,     3,     4,     2,     3,     5,     3,     2,     2,
       5,     2,     6,     3,     3,     3,     4,     7,     2,     5,
       2,     5,     3,     3,     5,     3,     3,     4,     2,     2,
       1,     3,     3,     3,     3,     9,     3,     1,     3,     3,
       3,     4,    10,     9,    13,     7,     4,     9,     2,     2,
       1,    12,     2,     1,     2,     4,     2,     3,     2,     6,
       3,     3,     7,     2,     5,     3,     2,     5,     4,     2,
       3,     6,     2,     1,     5,     3,     4,     5,     2,     2,
       2,     2,     3,     2,     8,     2,     2,     1,     6,     3,
       5,     3,     3,     9,     2,     3,     7,     3,     2,     1,
       1,     4,    10,     3,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,    34,    35,     3,     3,     0,
       3,     3,     3,     3,     0,     3,     3,     0,     0,     0,
       3,     3,     3,     0,     0,     0,     0,     0,     0,     0,
      70,     3,     0,     0,     0,     3,    77,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,    90,
       0,     0,    93,     0,     3,     0,     0,     3,     0,     0,
       0,     0,     0,     0,     3,     3,    23,     0,     0,     0,
     113,     0,     0,     0,     3,     0,     0,     0,     0,     0,
       3,     0,   127,     3,     0,     0,     0,     3,     0,     3,
       3,   139,   140,     0,     3,     0,     0,     0,   145,   146,
       0,     2,    28,    23,     0,    23,    23,     0,     0,     0,
       0,    41,     0,     0,    44,     3,     5,    48,    15,    16,
       0,    23,    49,     0,    51,     0,    23,     0,    23,     0,
       0,    58,     0,    60,     0,    23,    23,     0,     0,    23,
       0,    68,    69,    23,     0,    23,    23,     0,    23,     0,
      23,    23,     0,     0,     0,     0,     0,     0,     0,    88,
      89,     0,    92,    94,     0,    96,    23,    98,     0,    23,
      23,     0,   103,     0,     0,   106,     3,     3,   109,    25,
      23,     0,   112,     0,    23,     0,     0,   118,   119,   120,
     121,     0,   123,     0,   125,   126,     0,    23,     3,    23,
      23,     0,   134,    23,     0,    23,   138,     0,     3,    29,
      23,    23,     1,    27,    30,    23,    32,    33,     3,     5,
       3,     0,    42,     0,    45,     0,    18,     0,    47,     0,
       0,    53,    54,    55,     0,     0,     0,     0,    62,    63,
       0,    65,    66,     0,    71,    72,    73,    74,     0,    76,
      78,    79,    80,    23,     0,     0,     0,     0,    23,     0,
       3,     0,    97,     0,   100,   101,     0,     0,   105,     3,
      23,     3,    22,    25,   110,     0,     0,   115,     0,     0,
     122,     0,     0,   129,     3,   131,   132,     0,   135,     0,
     137,     0,     3,   144,   143,    31,     0,     0,     5,    20,
       0,     0,     0,    43,    21,    23,     0,     0,    56,     0,
       0,    23,    23,    67,     0,    81,     0,     0,     0,     0,
      86,     0,     0,    95,     0,     0,    23,    23,   108,     4,
      26,     6,     8,     9,     7,    24,     0,     0,   116,     0,
       0,     0,    23,     0,     0,   141,     3,    36,    37,    17,
      19,    38,    39,     0,    46,    50,    23,     0,    59,    61,
      64,     0,     0,     0,     0,     0,     0,     0,    23,     0,
     104,   107,     4,     0,    11,     0,   114,   117,     0,    23,
     130,     0,     0,     3,     0,    52,     0,     0,     0,     0,
       0,    23,     0,     0,    99,    23,     4,    13,    14,   111,
       0,   128,     0,    23,     3,    40,    57,     0,     0,     0,
       0,    85,     0,     0,   102,    10,    12,     0,     0,   136,
       3,    23,     0,    23,     0,    23,     3,   124,     0,     3,
      75,     0,    83,     0,    87,     0,   133,     3,    82,     0,
       0,   142,     0,    23,    23,    91,    84
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,   100,   108,   373,   225,   330,   331,   332,   333,   396,
     374,   117,   118,   119,   298,   226,   178,   179,   272,   273,
     101,   102
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -370
static const short yypact[] =
{
     553,    10,    14,    15,    17,  -370,  -370,    18,    19,    21,
      23,  -370,  -370,    25,    20,    26,    27,    30,    31,    32,
      33,    34,    35,    40,    41,    42,    43,    44,    45,    49,
    -370,  -370,    52,    53,    54,    55,  -370,    56,    59,    60,
      61,    62,    63,    66,    67,    69,    70,    71,  -370,  -370,
      73,    74,  -370,    75,    81,    72,    84,    83,    86,    87,
      88,    89,    90,    91,  -370,  -370,  -370,    94,    95,    96,
    -370,    97,   100,    99,   101,   102,   104,   103,   105,   106,
     107,   110,  -370,   109,   112,   113,   114,   115,   116,   118,
    -370,  -370,  -370,   119,  -370,   120,   123,   124,  -370,  -370,
      22,   553,  -370,  -370,   125,  -370,  -370,   126,    29,   127,
     128,  -370,   129,   130,  -370,  -370,    29,  -370,  -370,  -370,
     131,  -370,  -370,   132,  -370,   133,  -370,   136,  -370,   135,
     137,  -370,   138,  -370,   139,  -370,  -370,   142,   141,  -370,
     143,  -370,  -370,  -370,   144,  -370,  -370,   145,  -370,   146,
    -370,  -370,   147,   150,   153,   154,   155,   157,   158,  -370,
    -370,   161,  -370,  -370,   162,  -370,  -370,  -370,   163,  -370,
    -370,   164,  -370,   165,   166,  -370,  -370,  -370,  -370,   159,
    -370,   167,  -370,   168,  -370,   169,   171,  -370,  -370,  -370,
    -370,   172,  -370,   173,  -370,  -370,   174,  -370,  -370,  -370,
    -370,   175,  -370,  -370,   176,  -370,  -370,   177,  -370,  -370,
    -370,  -370,  -370,  -370,  -370,  -370,  -370,  -370,   160,  -370,
     180,   179,  -370,   182,  -370,   183,  -370,   184,  -370,   185,
     186,  -370,  -370,  -370,   187,   188,   189,   190,  -370,  -370,
     194,  -370,  -370,   193,  -370,  -370,  -370,  -370,   195,  -370,
    -370,  -370,  -370,  -370,   196,   199,   200,   201,  -370,   202,
    -370,   203,  -370,   204,  -370,  -370,   207,   206,  -370,  -370,
    -370,  -370,  -370,   159,  -370,   208,   210,  -370,   211,   212,
    -370,   213,   214,  -370,  -370,  -370,  -370,   216,  -370,   219,
    -370,   220,  -370,  -370,  -370,  -370,   221,   222,    38,  -370,
     223,   224,   225,  -370,  -370,  -370,   226,   227,  -370,   228,
     229,  -370,  -370,  -370,   230,  -370,   231,   234,   236,   235,
    -370,   238,   237,  -370,   239,   242,  -370,  -370,  -370,     6,
    -370,  -370,  -370,  -370,  -370,  -370,   244,   245,  -370,   246,
     250,   253,  -370,   259,   261,  -370,  -370,  -370,  -370,  -370,
    -370,  -370,  -370,   265,  -370,  -370,  -370,   266,  -370,  -370,
    -370,   268,   269,   272,   273,   274,   275,   276,  -370,   279,
    -370,  -370,   280,   281,  -370,   283,  -370,  -370,   284,  -370,
    -370,   285,   286,  -370,   287,  -370,   288,   289,   290,   291,
     295,  -370,   294,   297,  -370,  -370,    51,  -370,  -370,  -370,
     298,  -370,   299,  -370,  -370,  -370,  -370,   300,   301,   302,
     305,  -370,   304,   306,  -370,  -370,  -370,   307,   308,  -370,
    -370,  -370,   310,  -370,   313,  -370,  -370,  -370,   314,  -370,
    -370,   316,  -370,   321,  -370,   320,  -370,  -370,  -370,   324,
     325,  -370,   326,  -370,  -370,  -370,  -370
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -370,  -370,   -12,  -370,  -370,  -370,  -370,  -370,  -370,  -370,
    -369,   -23,    -6,  -370,  -370,  -213,   117,  -370,  -214,  -370,
    -370,   -36
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -6
static const short yytable[] =
{
     116,   109,   111,   397,   114,   115,   299,   121,   143,   124,
     126,    -5,   372,   103,   131,   133,   135,   104,   105,   116,
     106,   107,   212,   122,   110,   160,   112,   416,   113,   148,
     120,   123,   125,   127,   128,   219,   116,   129,   130,   132,
     134,   176,   177,   136,   137,   349,   139,   138,   165,   140,
     141,   169,   116,   116,   142,   144,   145,   146,   415,   335,
     147,   149,   150,   151,   152,   213,   154,   153,   187,   155,
     156,   208,   157,   158,   194,   166,   159,   197,   161,   162,
     163,   202,   116,   205,   206,   350,   164,   167,   168,   170,
     171,     0,   173,   172,     0,   174,   175,   180,   181,     0,
       0,   182,   183,   184,   185,   188,   186,   189,   190,   224,
     191,   192,   193,   195,   196,   198,   199,   200,     0,   203,
     201,     0,     0,   204,   207,   209,   210,   211,     0,     0,
     215,   218,   220,   221,   222,   223,   227,   229,   230,   232,
     234,     0,   235,   236,   237,   240,   241,     0,   243,   245,
     248,   250,   253,   269,   270,   254,   255,   256,   257,   299,
     258,   259,   271,   296,   116,   116,   260,   261,   263,   266,
     267,   268,   275,   276,   278,   284,   279,   280,   281,   282,
     287,   289,   291,   300,   302,   292,   116,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   116,   312,   313,     0,
     314,   316,   317,   318,   319,   321,     0,     0,   323,   324,
     325,   326,   297,   336,   301,   337,   338,   339,   340,   341,
     214,   343,   216,   217,   344,   345,   347,   348,   351,   352,
     353,   355,   356,   357,   358,   361,   362,   363,   228,   364,
     365,   366,   367,   231,   368,   233,   327,   369,   334,   375,
     376,   377,   238,   239,   322,   378,   242,   116,   379,   329,
     244,   342,   246,   247,   381,   249,   382,   251,   252,   346,
     384,   386,   116,   387,   388,   389,   390,     0,   392,   391,
     116,   393,   395,   262,   398,    -5,   264,   265,   399,   400,
     402,   403,   405,   406,   407,   408,   409,   274,   410,   412,
       0,   277,   413,   417,   418,   421,   422,   423,   424,   425,
       0,   426,   427,   428,   283,   431,   285,   286,   433,   436,
     288,   438,   290,   383,   439,   440,     0,   293,   294,   442,
     443,   444,   295,     0,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     315,   116,     0,     0,     0,   320,     0,     0,     0,     0,
       0,   420,     0,     0,     0,     0,     0,   328,     0,     0,
       0,     0,   116,     0,     0,     0,     0,   429,     0,     0,
       0,     0,     0,     0,     0,     0,   437,     0,   116,     0,
       0,     0,     0,     0,   441,     0,     0,   116,     0,     0,
     435,     0,   354,     0,     0,   116,     0,     0,   359,   360,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   370,   371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   380,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   385,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   394,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,     0,
       0,     0,   414,     0,     0,     0,     0,     0,     0,     0,
     419,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   430,     0,
     432,     0,   434,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     445,   446,     1,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99
};

static const short yycheck[] =
{
      12,     7,     8,   372,    10,    11,   219,    13,    31,    15,
      16,     5,     6,     3,    20,    21,    22,     3,     3,    31,
       3,     3,     0,     3,     5,    48,     5,   396,     5,    35,
       5,     5,     5,     3,     3,     6,    48,     5,     5,     5,
       5,    64,    65,     3,     3,     7,     3,     5,    54,     5,
       5,    57,    64,    65,     5,     3,     3,     3,     7,   273,
       5,     5,     3,     3,     3,   101,     3,     5,    74,     3,
       3,    94,     3,     3,    80,     3,     5,    83,     5,     5,
       5,    87,    94,    89,    90,   298,     5,     3,     5,     3,
       3,    -1,     3,     5,    -1,     5,     5,     3,     3,    -1,
      -1,     5,     5,     3,     5,     3,     5,     3,     5,   115,
       5,     5,     5,     3,     5,     3,     3,     3,    -1,     3,
       5,    -1,    -1,     5,     5,     5,     3,     3,    -1,    -1,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     3,
       5,    -1,     5,     5,     5,     3,     5,    -1,     5,     5,
       5,     5,     5,   176,   177,     5,     3,     3,     3,   372,
       3,     3,     3,     3,   176,   177,     5,     5,     5,     5,
       5,     5,     5,     5,     5,   198,     5,     5,     5,     5,
       5,     5,     5,     3,     5,   208,   198,     5,     5,     5,
       5,     5,     5,     5,     5,     5,   208,     3,     5,    -1,
       5,     5,     3,     3,     3,     3,    -1,    -1,     5,     5,
       3,     5,   218,     5,   220,     5,     5,     5,     5,     5,
     103,     5,   105,   106,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     3,   121,     3,
       5,     3,     5,   126,     5,   128,   269,     5,   271,     5,
       5,     5,   135,   136,   260,     5,   139,   269,     5,   271,
     143,   284,   145,   146,     5,   148,     5,   150,   151,   292,
       5,     5,   284,     5,     5,     3,     3,    -1,     3,     5,
     292,     5,     3,   166,     3,     5,   169,   170,     5,     5,
       5,     5,     5,     5,     5,     5,     5,   180,     3,     5,
      -1,   184,     5,     5,     5,     5,     5,     5,     3,     5,
      -1,     5,     5,     5,   197,     5,   199,   200,     5,     5,
     203,     5,   205,   346,     3,     5,    -1,   210,   211,     5,
       5,     5,   215,    -1,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,   383,    -1,    -1,    -1,   258,    -1,    -1,    -1,    -1,
      -1,   404,    -1,    -1,    -1,    -1,    -1,   270,    -1,    -1,
      -1,    -1,   404,    -1,    -1,    -1,    -1,   420,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   429,    -1,   420,    -1,
      -1,    -1,    -1,    -1,   437,    -1,    -1,   429,    -1,    -1,
     426,    -1,   305,    -1,    -1,   437,    -1,    -1,   311,   312,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,   327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   356,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   379,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,
      -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,
     423,    -1,   425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     443,   444,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     110,   129,   130,     3,     3,     3,     3,     3,   111,   121,
       5,   121,     5,     5,   121,   121,   111,   120,   121,   122,
       5,   121,     3,     5,   121,     5,   121,     3,     3,     5,
       5,   121,     5,   121,     5,   121,     3,     3,     5,     3,
       5,     5,     5,   120,     3,     3,     3,     5,   121,     5,
       3,     3,     3,     5,     3,     3,     3,     3,     3,     5,
     120,     5,     5,     5,     5,   121,     3,     3,     5,   121,
       3,     3,     5,     3,     5,     5,   120,   120,   125,   126,
       3,     3,     5,     5,     3,     5,     5,   121,     3,     3,
       5,     5,     5,     5,   121,     3,     5,   121,     3,     3,
       3,     5,   121,     3,     5,   121,   121,     5,   120,     5,
       3,     3,     0,   130,   125,     5,   125,   125,     5,     6,
       5,     5,     5,     5,   121,   113,   124,     5,   125,     5,
       5,   125,     3,   125,     5,     5,     5,     5,   125,   125,
       3,     5,   125,     5,   125,     5,   125,   125,     5,   125,
       5,   125,   125,     5,     5,     3,     3,     3,     3,     3,
       5,     5,   125,     5,   125,   125,     5,     5,     5,   120,
     120,     3,   127,   128,   125,     5,     5,   125,     5,     5,
       5,     5,     5,   125,   120,   125,   125,     5,   125,     5,
     125,     5,   120,   125,   125,   125,     3,   121,   123,   124,
       3,   121,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     3,     5,     5,   125,     5,     3,     3,     3,
     125,     3,   121,     5,     5,     3,     5,   120,   125,   111,
     114,   115,   116,   117,   120,   127,     5,     5,     5,     5,
       5,     5,   120,     5,     5,     5,   120,     5,     5,     7,
     124,     5,     5,     5,   125,     5,     5,     5,     5,   125,
     125,     5,     5,     3,     3,     5,     3,     5,     5,     5,
     125,   125,     6,   112,   119,     5,     5,     5,     5,     5,
     125,     5,     5,   120,     5,   125,     5,     5,     5,     3,
       3,     5,     3,     5,   125,     3,   118,   119,     3,     5,
       5,   125,     5,     5,   120,     5,     5,     5,     5,     5,
       3,   125,     5,     5,   125,     7,   119,     5,     5,   125,
     120,     5,     5,     5,     3,     5,     5,     5,     5,   120,
     125,     5,   125,     5,   125,   121,     5,   120,     5,     3,
       5,   120,     5,     5,     5,   125,   125
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 171 "ri/ribparse.y"
    {
	if (cur_array) ArrayFree( cur_array );
	cur_array = new RIB_array;
	cur_array->allocated = 0;
	cur_array->nelems = 0;
	cur_array->array = NULL;
;}
    break;

  case 4:
#line 180 "ri/ribparse.y"
    {
	cur_array->element_size = sizeof( const char * );
;}
    break;

  case 5:
#line 185 "ri/ribparse.y"
    {
	cur_array->element_size = sizeof( Float );
;}
    break;

  case 6:
#line 190 "ri/ribparse.y"
    {
	yyval.ribarray = yyvsp[0].ribarray;
;}
    break;

  case 7:
#line 194 "ri/ribparse.y"
    {
	yyval.ribarray = yyvsp[0].ribarray;
;}
    break;

  case 8:
#line 199 "ri/ribparse.y"
    {
	yyval.ribarray = yyvsp[0].ribarray;
;}
    break;

  case 9:
#line 203 "ri/ribparse.y"
    {
	yyval.ribarray = ArrayDup(cur_array);
;}
    break;

  case 10:
#line 208 "ri/ribparse.y"
    {
	yyval.ribarray = ArrayDup(cur_array);
;}
    break;

  case 14:
#line 217 "ri/ribparse.y"
    {
	char *to_add = strdup(yyvsp[0].string);
	AddArrayElement( &to_add );
;}
    break;

  case 15:
#line 223 "ri/ribparse.y"
    {
	yyval.ribarray = yyvsp[0].ribarray;
;}
    break;

  case 16:
#line 227 "ri/ribparse.y"
    {
	yyval.ribarray = ArrayDup(cur_array);
;}
    break;

  case 17:
#line 232 "ri/ribparse.y"
    {
	yyval.ribarray = ArrayDup(cur_array);
;}
    break;

  case 21:
#line 241 "ri/ribparse.y"
    {
	Float to_add = yyvsp[0].num;
	AddArrayElement( &to_add );
;}
    break;

  case 23:
#line 249 "ri/ribparse.y"
    {
	cur_paramlist_size = 0;
;}
    break;

  case 26:
#line 257 "ri/ribparse.y"
    {
	void *arg = new char[ yyvsp[0].ribarray->nelems * yyvsp[0].ribarray->element_size ];
	memcpy(arg, yyvsp[0].ribarray->array, yyvsp[0].ribarray->nelems * yyvsp[0].ribarray->element_size);
	if (cur_paramlist_size >= cur_paramlist_allocated) {
		cur_paramlist_allocated = 2*cur_paramlist_allocated + 1;
		cur_paramlist_tokens = (const char **) realloc(cur_paramlist_tokens, cur_paramlist_allocated*sizeof(const char *) );
		cur_paramlist_args = (void * *) realloc( cur_paramlist_args, cur_paramlist_allocated*sizeof(void *) );
		cur_paramlist_sizes = (int *) realloc( cur_paramlist_sizes, cur_paramlist_allocated*sizeof(int) );
	}
	cur_paramlist_tokens[cur_paramlist_size] = yyvsp[-1].string;
	cur_paramlist_sizes[cur_paramlist_size] = yyvsp[0].ribarray->nelems;
	cur_paramlist_args[cur_paramlist_size++] = arg;
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 29:
#line 275 "ri/ribparse.y"
    { ;}
    break;

  case 30:
#line 277 "ri/ribparse.y"
    {
	RiAcceleratorV(yyvsp[-1].string, CPS, CPT, CPA);
	FreeArgs();
;}
    break;

  case 31:
#line 282 "ri/ribparse.y"
    {
    int num = (int)yyvsp[-1].num;
	if (num < 0 || num >= MAX_LIGHT_HANDLE)
		Error("Invalid light handle %d passed to AreaLightSource. Ignoring.", num);
	else
		lights[num] = RiAreaLightSourceV( yyvsp[-2].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 32:
#line 291 "ri/ribparse.y"
    {
	RiAtmosphereV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 33:
#line 296 "ri/ribparse.y"
    {
	RiAttributeV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 34:
#line 301 "ri/ribparse.y"
    {
	RiAttributeBegin();
;}
    break;

  case 35:
#line 305 "ri/ribparse.y"
    {
	RiAttributeEnd();
;}
    break;

  case 36:
#line 309 "ri/ribparse.y"
    {
	Float * basis1 = FindBasis( yyvsp[-3].string );
	Float * basis2 = FindBasis( yyvsp[-1].string );
	RiBasis( basis1, int(yyvsp[-2].num), basis2, int(yyvsp[0].num) );
;}
    break;

  case 37:
#line 315 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 16, "Basis" )) {
		Float * basis1 = FindBasis( yyvsp[-3].string );
		RiBasis( basis1, int(yyvsp[-2].num), (Float *) yyvsp[-1].ribarray->array, int(yyvsp[0].num) );
	}
	ArrayFree( yyvsp[-1].ribarray );
;}
    break;

  case 38:
#line 323 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-3].ribarray, 16, "Basis" )) {
		Float * basis2 = FindBasis( yyvsp[-1].string );
		RiBasis( (Float *) yyvsp[-3].ribarray->array, int(yyvsp[-2].num), basis2, int(yyvsp[0].num) );
	}
	ArrayFree( yyvsp[-3].ribarray );
;}
    break;

  case 39:
#line 331 "ri/ribparse.y"
    {
	if (VerifyArrayLength(yyvsp[-3].ribarray, 16, "Basis") && VerifyArrayLength(yyvsp[-1].ribarray, 16, "Basis"))
		RiBasis( (Float *) yyvsp[-3].ribarray->array, int(yyvsp[-2].num), (Float *) yyvsp[-1].ribarray->array, int(yyvsp[0].num) );
	ArrayFree( yyvsp[-3].ribarray );
	ArrayFree( yyvsp[-1].ribarray );
;}
    break;

  case 40:
#line 338 "ri/ribparse.y"
    {
	Float bound[6];
	bound[0] = yyvsp[-5].num; bound[1] = yyvsp[-4].num; bound[2] = yyvsp[-3].num;
	bound[3] = yyvsp[-2].num; bound[4] = yyvsp[-1].num; bound[5] = yyvsp[0].num;
	RiBound( bound );
;}
    break;

  case 41:
#line 345 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 6, "Bound" ))
		RiBound( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 42:
#line 351 "ri/ribparse.y"
    {
	RiClipping( yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 43:
#line 355 "ri/ribparse.y"
    {
	Assert(COLOR_SAMPLES == 3);
	Float color[3];
	color[0] = yyvsp[-2].num; color[1] = yyvsp[-1].num; color[2] = yyvsp[0].num;
	RiColor( color );
;}
    break;

  case 44:
#line 362 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 3, "Color" ))
		RiColor( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 45:
#line 368 "ri/ribparse.y"
    {
	if (yyvsp[-1].ribarray->nelems != yyvsp[0].ribarray->nelems) {
		ParseError( "The two arrays should be the same size in ColorSamples" );
		goto noGoodColor;
	}
	if (yyvsp[-1].ribarray->nelems % 3 != 0) {
		ParseError( "The two arrays should be the multiples of 3 in ColorSamples" );
		goto noGoodColor;
	}
	RiColorSamples( yyvsp[-1].ribarray->nelems / 3, NA(yyvsp[-1].ribarray), NA(yyvsp[0].ribarray) );
noGoodColor:
	ArrayFree( yyvsp[-1].ribarray );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 46:
#line 383 "ri/ribparse.y"
    {
	RiConeV( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 47:
#line 388 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 3, "Cone" ))
		RiConeV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 48:
#line 394 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 16, "ConcatTransform" ))
		RiConcatTransform( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 49:
#line 400 "ri/ribparse.y"
    {
	RiCoordinateSystem( yyvsp[0].string );
;}
    break;

  case 50:
#line 404 "ri/ribparse.y"
    {
	RiCropWindow( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 51:
#line 408 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 4, "CropWindow" ))
		RiCropWindow( NA(yyvsp[0].ribarray)[0], NA(yyvsp[0].ribarray)[1], NA(yyvsp[0].ribarray)[2], NA(yyvsp[0].ribarray)[3] );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 52:
#line 414 "ri/ribparse.y"
    {
	RiCylinderV( yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 53:
#line 419 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 4, "Cylinder" ))
		RiCylinderV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], NA(yyvsp[-1].ribarray)[3], CPS, CPT, CPA );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 54:
#line 426 "ri/ribparse.y"
    {
	RiDeclare( yyvsp[-1].string, yyvsp[0].string );
;}
    break;

  case 55:
#line 430 "ri/ribparse.y"
    {
	RiDeformationV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 56:
#line 435 "ri/ribparse.y"
    {
	RiDepthOfField( yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 57:
#line 439 "ri/ribparse.y"
    {
	Float bound[6];
	bound[0] = yyvsp[-5].num; bound[1] = yyvsp[-4].num; bound[2] = yyvsp[-3].num;
	bound[3] = yyvsp[-2].num; bound[4] = yyvsp[-1].num; bound[5] = yyvsp[0].num;
	RiDetail( bound );
;}
    break;

  case 58:
#line 446 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 6, "Detail" ))
		RiDetail( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 59:
#line 452 "ri/ribparse.y"
    {
	RiDetailRange( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 60:
#line 456 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 4, "DetailRange" ))
		RiDetailRange( NA(yyvsp[0].ribarray)[0], NA(yyvsp[0].ribarray)[1], NA(yyvsp[0].ribarray)[2], NA(yyvsp[0].ribarray)[3] );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 61:
#line 462 "ri/ribparse.y"
    {
	RiDiskV( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 62:
#line 467 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 3, "Disk" ))
		RiDiskV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], CPS, CPT, CPA );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 63:
#line 474 "ri/ribparse.y"
    {
	RiDisplacementV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 64:
#line 479 "ri/ribparse.y"
    {
	RiDisplayV( yyvsp[-3].string, yyvsp[-2].string, yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 65:
#line 484 "ri/ribparse.y"
    {
	RiExposure( yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 66:
#line 488 "ri/ribparse.y"
    {
	RiExteriorV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 67:
#line 493 "ri/ribparse.y"
    {
	RiFormat( int(yyvsp[-2].num), int(yyvsp[-1].num), yyvsp[0].num );
;}
    break;

  case 68:
#line 497 "ri/ribparse.y"
    {
	RiFrameAspectRatio( yyvsp[0].num );
;}
    break;

  case 69:
#line 501 "ri/ribparse.y"
    {
	RiFrameBegin( int(yyvsp[0].num) );
;}
    break;

  case 70:
#line 505 "ri/ribparse.y"
    {
	RiFrameEnd();
;}
    break;

  case 71:
#line 509 "ri/ribparse.y"
    {
	int *verts = MakeIntArray( yyvsp[-1].ribarray );
	RiGeneralPolygonV( yyvsp[-1].ribarray->nelems, verts, CPS, CPT, CPA );
	delete [] verts;
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 72:
#line 517 "ri/ribparse.y"
    {
	RiGeometricApproximation( yyvsp[-1].string, yyvsp[0].num );
;}
    break;

  case 73:
#line 521 "ri/ribparse.y"
    {
	RiGeometryV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 74:
#line 526 "ri/ribparse.y"
    {
	RiHiderV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 75:
#line 531 "ri/ribparse.y"
    {
	Float point1[3], point2[3];
	point1[0] = yyvsp[-7].num; point1[1] = yyvsp[-6].num; point1[2] = yyvsp[-5].num;
	point2[0] = yyvsp[-4].num; point2[1] = yyvsp[-3].num; point2[2] = yyvsp[-2].num;
	RiHyperboloidV( point1, point2, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 76:
#line 539 "ri/ribparse.y"
    {
	Float point1[3], point2[3];
	if (VerifyArrayLength( yyvsp[-1].ribarray, 7, "Hyperboloid" )) {
		point1[0] = NA(yyvsp[-1].ribarray)[0]; point1[1] = NA(yyvsp[-1].ribarray)[1]; point1[2] = NA(yyvsp[-1].ribarray)[2];
		point2[0] = NA(yyvsp[-1].ribarray)[3]; point2[1] = NA(yyvsp[-1].ribarray)[4]; point2[2] = NA(yyvsp[-1].ribarray)[5];
		RiHyperboloidV( point1, point2, NA(yyvsp[-1].ribarray)[6], CPS, CPT, CPA );
	}
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 77:
#line 550 "ri/ribparse.y"
    {
	RiIdentity();
;}
    break;

  case 78:
#line 554 "ri/ribparse.y"
    {
    int num = (int)yyvsp[-1].num;
	bool light_on = (yyvsp[0].num == 1.0f) ? true : false;
	if (num < 0 || num >= MAX_LIGHT_HANDLE)
		Error("Invalid light handle %d passed to Illuminate. Ignoring.", num);
	else {
		void *light = lights[num];
		if (!light)
			ParseError( "Unknown light number: %d", num);
		else
			RiIlluminate( light, light_on );
	}
;}
    break;

  case 79:
#line 568 "ri/ribparse.y"
    {
	RiImagerV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 80:
#line 573 "ri/ribparse.y"
    {
	RiInteriorV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 81:
#line 578 "ri/ribparse.y"
    {
    int num = (int)yyvsp[-1].num;
	if (num < 0 || num >= MAX_LIGHT_HANDLE)
		Error("Invalid light handle %d passed to LightSource. Ignoring.", num);
	else
		lights[num] = RiLightSourceV( yyvsp[-2].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 82:
#line 587 "ri/ribparse.y"
    {
	RiLookAt(yyvsp[-8].num, yyvsp[-7].num, yyvsp[-6].num, yyvsp[-5].num, yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num);
;}
    break;

  case 83:
#line 591 "ri/ribparse.y"
    {
	RiMakeBumpV( yyvsp[-7].string, yyvsp[-6].string, yyvsp[-5].string, yyvsp[-4].string, yyvsp[-3].string, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 84:
#line 596 "ri/ribparse.y"
    {
	RiMakeCubeFaceEnvironmentV( yyvsp[-11].string, yyvsp[-10].string, yyvsp[-9].string, yyvsp[-8].string, yyvsp[-7].string, yyvsp[-6].string, yyvsp[-5].string, yyvsp[-4].num, yyvsp[-3].string,
		yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 85:
#line 602 "ri/ribparse.y"
    {
	RiMakeLatLongEnvironmentV( yyvsp[-5].string, yyvsp[-4].string, yyvsp[-3].string, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 86:
#line 607 "ri/ribparse.y"
    {
	RiMakeShadowV( yyvsp[-2].string, yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 87:
#line 612 "ri/ribparse.y"
    {
	RiMakeTextureV( yyvsp[-7].string, yyvsp[-6].string, yyvsp[-5].string, yyvsp[-4].string, yyvsp[-3].string, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 88:
#line 617 "ri/ribparse.y"
    {
	RiMatte( yyvsp[0].num != 0. );
;}
    break;

  case 89:
#line 621 "ri/ribparse.y"
    {
	RiMotionBeginV( yyvsp[0].ribarray->nelems, NA(yyvsp[0].ribarray) );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 90:
#line 626 "ri/ribparse.y"
    {
	RiMotionEnd();
;}
    break;

  case 91:
#line 630 "ri/ribparse.y"
    {
	RiNuPatchV( int(yyvsp[-10].num), int(yyvsp[-9].num), NA(yyvsp[-8].ribarray), yyvsp[-7].num, yyvsp[-6].num,
				int(yyvsp[-5].num), int(yyvsp[-4].num), NA(yyvsp[-3].ribarray), yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	ArrayFree(yyvsp[-8].ribarray);
	ArrayFree(yyvsp[-3].ribarray);
	FreeArgs();
;}
    break;

  case 92:
#line 638 "ri/ribparse.y"
    {
	Warning( "Don't know how to parse ObjectInstance" );
;}
    break;

  case 93:
#line 642 "ri/ribparse.y"
    {
	RiObjectEnd();
;}
    break;

  case 94:
#line 646 "ri/ribparse.y"
    {
	Warning( "Don't know how to parse ObjectInstance" );
;}
    break;

  case 95:
#line 650 "ri/ribparse.y"
    {
	Float color[3];
	color[0] = yyvsp[-2].num; color[1] = yyvsp[-1].num; color[2] = yyvsp[0].num;
	RiOpacity( color );
;}
    break;

  case 96:
#line 656 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 3, "Opacity" ))
		RiOpacity( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 97:
#line 662 "ri/ribparse.y"
    {
	RiOptionV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 98:
#line 667 "ri/ribparse.y"
    {
	RiOrientation( yyvsp[0].string );
;}
    break;

  case 99:
#line 671 "ri/ribparse.y"
    {
	RiParaboloidV( yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 100:
#line 676 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 4, "Paraboloid" ))
		RiParaboloidV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], NA(yyvsp[-1].ribarray)[3], CPS, CPT, CPA );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 101:
#line 683 "ri/ribparse.y"
    {
	RiPatchV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 102:
#line 688 "ri/ribparse.y"
    {
	RiPatchMeshV( yyvsp[-5].string, int(yyvsp[-4].num), yyvsp[-3].string, int(yyvsp[-2].num), yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 103:
#line 693 "ri/ribparse.y"
    {
	RiPerspective( yyvsp[0].num );
;}
    break;

  case 104:
#line 697 "ri/ribparse.y"
    {
	RiPixelFilter( yyvsp[-3].string, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 105:
#line 702 "ri/ribparse.y"
    {
	RiPixelSamples( yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 106:
#line 706 "ri/ribparse.y"
    {
	RiPixelVariance( yyvsp[0].num );
;}
    break;

  case 107:
#line 710 "ri/ribparse.y"
    {
	int *nloops, *nvertices, *vertices;

	nloops = MakeIntArray( yyvsp[-3].ribarray );
	nvertices = MakeIntArray( yyvsp[-2].ribarray );
	vertices = MakeIntArray( yyvsp[-1].ribarray );

	RiPointsGeneralPolygonsV( yyvsp[-3].ribarray->nelems, nloops, nvertices, vertices, CPS, CPT, CPA );

	delete [] nloops;
	delete [] nvertices;
	delete [] vertices;
	ArrayFree( yyvsp[-3].ribarray );
	ArrayFree( yyvsp[-2].ribarray );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 108:
#line 728 "ri/ribparse.y"
    {
	// Gotta convert these bad boys to arrays of integers.  that sucks.
	int *nverts, *verts;

	nverts = MakeIntArray( yyvsp[-2].ribarray );
	verts = MakeIntArray( yyvsp[-1].ribarray );
	int tot = 0;
	for (int i = 0 ; i < yyvsp[-2].ribarray->nelems ; i++)
		tot += nverts[i];
	if (tot != yyvsp[-1].ribarray->nelems)
		ParseError("Wrong number of vertex elements in PointsPolygons. Ignoring.");
	else
		RiPointsPolygonsV( yyvsp[-2].ribarray->nelems, nverts, verts, CPS, CPT, CPA );

	delete [] nverts;
	delete [] verts;
	ArrayFree( yyvsp[-2].ribarray );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 109:
#line 749 "ri/ribparse.y"
    {
	int num_verts = -1;

	for (int i = 0 ; i < CPS ; i++) {
		if (strcmp(CPT[i], "P") == 0) {
			num_verts = CPSZ[i];
			if (num_verts % 3 != 0) {
				ParseError("Polygon P array must be 3*n in length." );
				goto noGoodPolygon;
			}
			num_verts /= 3;
			break;
		}
	}
	if (num_verts == -1)
		ParseError( "Polygon without a \"P\" parameter???" );
	else
		RiPolygonV( num_verts, CPS, CPT, CPA );
noGoodPolygon:
	FreeArgs();
;}
    break;

  case 110:
#line 771 "ri/ribparse.y"
    {
	RiProjectionV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 111:
#line 776 "ri/ribparse.y"
    {
	RiQuantize( yyvsp[-4].string, int(yyvsp[-3].num), int(yyvsp[-2].num), int(yyvsp[-1].num), yyvsp[0].num );
;}
    break;

  case 112:
#line 780 "ri/ribparse.y"
    {
	RiRelativeDetail( yyvsp[0].num );
;}
    break;

  case 113:
#line 784 "ri/ribparse.y"
    {
	RiReverseOrientation();
;}
    break;

  case 114:
#line 788 "ri/ribparse.y"
    {
	RiRotate( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 115:
#line 792 "ri/ribparse.y"
    {
	RiSamplerV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 116:
#line 797 "ri/ribparse.y"
    {
	RiScale( yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 117:
#line 801 "ri/ribparse.y"
    {
	RiScreenWindow( yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 118:
#line 805 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 4, "ScreenWindow" ))
		RiScreenWindow( NA(yyvsp[0].ribarray)[0], NA(yyvsp[0].ribarray)[1], NA(yyvsp[0].ribarray)[2], NA(yyvsp[0].ribarray)[3] );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 119:
#line 811 "ri/ribparse.y"
    {
	RiSearchPath(yyvsp[0].string);
;}
    break;

  case 120:
#line 815 "ri/ribparse.y"
    {
	RiShadingInterpolation( yyvsp[0].string );
;}
    break;

  case 121:
#line 819 "ri/ribparse.y"
    {
	RiShadingRate( yyvsp[0].num );
;}
    break;

  case 122:
#line 823 "ri/ribparse.y"
    {
	RiShutter( yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 123:
#line 827 "ri/ribparse.y"
    {
	RiSides( int(yyvsp[0].num) );
;}
    break;

  case 124:
#line 831 "ri/ribparse.y"
    {
	RiSkew( yyvsp[-6].num, yyvsp[-5].num, yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 125:
#line 835 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 7, "Skew" ))
		RiSkew( NA(yyvsp[0].ribarray)[0], NA(yyvsp[0].ribarray)[1], NA(yyvsp[0].ribarray)[2], NA(yyvsp[0].ribarray)[3],
				NA(yyvsp[0].ribarray)[4], NA(yyvsp[0].ribarray)[5], NA(yyvsp[0].ribarray)[6] );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 126:
#line 842 "ri/ribparse.y"
    {
	RiSolidBegin( yyvsp[0].string );
;}
    break;

  case 127:
#line 846 "ri/ribparse.y"
    {
	RiSolidEnd();
;}
    break;

  case 128:
#line 850 "ri/ribparse.y"
    {
	RiSphereV( yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 129:
#line 855 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 4, "Sphere" ))
		RiSphereV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], NA(yyvsp[-1].ribarray)[3], CPS, CPT, CPA );
	ArrayFree( yyvsp[-1].ribarray );
	FreeArgs();
;}
    break;

  case 130:
#line 862 "ri/ribparse.y"
    {
	int *nvertices = MakeIntArray(yyvsp[-2].ribarray);
	int nfaces = yyvsp[-2].ribarray->nelems;
	int *verts = MakeIntArray(yyvsp[-1].ribarray);
	int tot = 0;
	for (int i = 0 ; i < nfaces; i++)
		tot += nvertices[i];
	if (tot != yyvsp[-1].ribarray->nelems)
		ParseError("Wrong number of vertex elements in SubdivisionMesh. Ignoring.");
	else {
		// XXX ignore tags here
		const char *noTags[] = { NULL };
		int noTagsCount[2] = { 0, 0 };
		int noIntTags[] = { 0 };
		Float noFloatTags[] = { 0 };
		RiSubdivisionMeshV(yyvsp[-3].string, nfaces, nvertices, verts, 0, noTags,
			noTagsCount, noIntTags, noFloatTags, CPS, CPT, CPA);
	}
	ArrayFree(yyvsp[-2].ribarray);
	ArrayFree(yyvsp[-1].ribarray);
	delete[] nvertices;
	delete[] verts;
	FreeArgs();
;}
    break;

  case 131:
#line 887 "ri/ribparse.y"
    {
	RiSurfaceV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 132:
#line 892 "ri/ribparse.y"
    {
	RiSurfaceIntegratorV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 133:
#line 897 "ri/ribparse.y"
    {
	RiTextureCoordinates( yyvsp[-7].num, yyvsp[-6].num, yyvsp[-5].num, yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 134:
#line 901 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 8, "TextureCoordinates" ))
		RiTextureCoordinates( NA(yyvsp[0].ribarray)[0], NA(yyvsp[0].ribarray)[1], NA(yyvsp[0].ribarray)[2], NA(yyvsp[0].ribarray)[3],
							  NA(yyvsp[0].ribarray)[4], NA(yyvsp[0].ribarray)[5], NA(yyvsp[0].ribarray)[7], NA(yyvsp[0].ribarray)[8] );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 135:
#line 908 "ri/ribparse.y"
    {
	RiToneMap(yyvsp[-1].string, CPS, CPT, CPA);
	FreeArgs();
;}
    break;

  case 136:
#line 913 "ri/ribparse.y"
    {
	RiTorusV( yyvsp[-5].num, yyvsp[-4].num, yyvsp[-3].num, yyvsp[-2].num, yyvsp[-1].num, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 137:
#line 918 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[-1].ribarray, 5, "Torus" ))
		RiTorusV( NA(yyvsp[-1].ribarray)[0], NA(yyvsp[-1].ribarray)[1], NA(yyvsp[-1].ribarray)[2], NA(yyvsp[-1].ribarray)[3], NA(yyvsp[-1].ribarray)[4],
			CPS, CPT, CPA );
    ArrayFree(yyvsp[-1].ribarray);
	FreeArgs();
;}
    break;

  case 138:
#line 926 "ri/ribparse.y"
    {
	if (VerifyArrayLength( yyvsp[0].ribarray, 16, "Transform" ))
		RiTransform( (Float *) yyvsp[0].ribarray->array );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 139:
#line 932 "ri/ribparse.y"
    {
	RiTransformBegin();
;}
    break;

  case 140:
#line 936 "ri/ribparse.y"
    {
	RiTransformEnd();
;}
    break;

  case 141:
#line 940 "ri/ribparse.y"
    {
	RiTranslate( yyvsp[-2].num, yyvsp[-1].num, yyvsp[0].num );
;}
    break;

  case 142:
#line 944 "ri/ribparse.y"
    {
	int *ncurves, *order, *n;

	ncurves = MakeIntArray( yyvsp[-8].ribarray );
	order = MakeIntArray( yyvsp[-7].ribarray );
	n = MakeIntArray( yyvsp[-3].ribarray );

	RiTrimCurve( yyvsp[-8].ribarray->nelems, ncurves, order, NA(yyvsp[-6].ribarray), NA(yyvsp[-5].ribarray), NA(yyvsp[-4].ribarray), n, NA(yyvsp[-2].ribarray), NA(yyvsp[-1].ribarray), NA(yyvsp[0].ribarray) );
	delete [] ncurves;
	delete [] order;
	delete [] n;

	ArrayFree( yyvsp[-8].ribarray );
	ArrayFree( yyvsp[-7].ribarray );
	ArrayFree( yyvsp[-6].ribarray );
	ArrayFree( yyvsp[-5].ribarray );
	ArrayFree( yyvsp[-4].ribarray );
	ArrayFree( yyvsp[-3].ribarray );
	ArrayFree( yyvsp[-2].ribarray );
	ArrayFree( yyvsp[-1].ribarray );
	ArrayFree( yyvsp[0].ribarray );
;}
    break;

  case 143:
#line 967 "ri/ribparse.y"
    {
	RiVolumeIntegratorV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 144:
#line 972 "ri/ribparse.y"
    {
	RiVolumeV( yyvsp[-1].string, CPS, CPT, CPA );
	FreeArgs();
;}
    break;

  case 145:
#line 977 "ri/ribparse.y"
    {
	RiWorldBegin();
;}
    break;

  case 146:
#line 981 "ri/ribparse.y"
    {
	RiWorldEnd();
;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2910 "ri/ribparse.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 273 "ri/ribparse.y"


