// tonemap.h*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#ifndef TONEMAP_H
#define TONEMAP_H 1
#include "lrt.h"
#include "film.h"
// ToneMap Declarations
class ToneMap {
public:
	// ToneMap Interface
	virtual ~ToneMap() { }
	virtual void Map(Float *xyz, int xRes, int yRes,
		const DisplayInfo &di) const = 0;
};
#define X(i) (xyz[3*(i)])
#define Y(i) (xyz[3*(i)+1])
#define Z(i) (xyz[3*(i)+2])
#endif // TONEMAP_H
